#include "TestClass.h"

using namespace std;

TestClass::TestClass()
{
    value = 0;
    tmpValue = 0;
}

TestClass::TestClass(const TestClass& a) :
        value(a.value),
        tmpValue(1)
        // Initialization list.
{

}

TestClass::TestClass(const double& value)
{
    this->value = value;
}

// Destructor.
TestClass::~TestClass()
{
    value = 0;
}

// Member functions (e.g. getters and setters).
double TestClass::getValue() const
{
    return value;
}

void TestClass::setValue(double value)
{
    this->value = value;
}

// Member operators (e.g. unary operator =).
TestClass& TestClass::operator=(const TestClass& a)
{
    value = a.value;

    return *this;
}

// Friend operators (e.g. binary operator).
ostream& operator<<(ostream& os, const TestClass& a)
{
    os << "Value = " << a.value;
    return os;
}

// Friend functions.
TestClass compute(const TestClass& a, const TestClass& b)
{
    TestClass c;

    c.setValue(a.value + 2* b.value);

    return c;
}
